<html>
<head>
<title>thermalbg_hzg.ipynb</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<style type="text/css">
.s0 { color: #808080;}
.s1 { color: #a9b7c6;}
.s2 { color: #cc7832;}
.s3 { color: #6a8759;}
.s4 { color: #6897bb;}
.s5 { color: #629755; font-style: italic;}
.ln { color: #606366; font-weight: normal; font-style: normal; }
</style>
</head>
<body bgcolor="#2b2b2b">
<table CELLSPACING=0 CELLPADDING=5 COLS=1 WIDTH="100%" BGCOLOR="#606060" >
<tr><td><center>
<font face="Arial, Helvetica" color="#000000">
thermalbg_hzg.ipynb</font>
</center></td></tr></table>
<pre><a name="l1"><span class="ln">1    </span></a><span class="s0">#%% md 
<a name="l2"><span class="ln">2    </span></a></span><span class="s1"># Thermal emission noise of HZG NIT ch4 
<a name="l3"><span class="ln">3    </span></a>2022-03-28 H. Akitaya (PERC, CIT) 
<a name="l4"><span class="ln">4    </span></a></span><span class="s0">#%% md 
<a name="l5"><span class="ln">5    </span></a></span><span class="s1">## Instrumental parameters. 
<a name="l6"><span class="ln">6    </span></a></span><span class="s0">#%% 
<a name="l7"><span class="ln">7    </span></a></span><span class="s2">from </span><span class="s1">hzgdev.phot </span><span class="s2">import </span><span class="s1">simimg</span>
<a name="l8"><span class="ln">8    </span></a><span class="s0">#%% 
<a name="l9"><span class="ln">9    </span></a></span><span class="s1">params = simimg.HZGParams()</span>
<a name="l10"><span class="ln">10   </span></a><span class="s0">#%% 
<a name="l11"><span class="ln">11   </span></a># Get attributions.</span>
<a name="l12"><span class="ln">12   </span></a><span class="s1">attars = [x </span><span class="s2">for </span><span class="s1">x </span><span class="s2">in </span><span class="s1">dir(params) </span><span class="s2">if not </span><span class="s1">x.startswith(</span><span class="s3">'_'</span><span class="s1">)]</span>
<a name="l13"><span class="ln">13   </span></a><span class="s0">#%% 
<a name="l14"><span class="ln">14   </span></a></span><span class="s1">attars = [x </span><span class="s2">for </span><span class="s1">x </span><span class="s2">in </span><span class="s1">dir(params) </span><span class="s2">if not </span><span class="s1">x.startswith(</span><span class="s3">'_'</span><span class="s1">)]</span>
<a name="l15"><span class="ln">15   </span></a><span class="s0"># Show attributions.</span>
<a name="l16"><span class="ln">16   </span></a><span class="s2">for </span><span class="s1">attar </span><span class="s2">in </span><span class="s1">attars:</span>
<a name="l17"><span class="ln">17   </span></a>    <span class="s1">print(</span><span class="s3">'params.{} = {}'</span><span class="s1">.format(attar</span><span class="s2">, </span><span class="s1">getattr(params</span><span class="s2">, </span><span class="s1">attar)))</span>
<a name="l18"><span class="ln">18   </span></a><span class="s0">#%% 
<a name="l19"><span class="ln">19   </span></a></span><span class="s1">n_pix = </span><span class="s4">9.0  </span><span class="s0"># Number of pixels in a photometry aperture.</span>
<a name="l20"><span class="ln">20   </span></a><span class="s1">zd_elat = </span><span class="s4">45.0  </span><span class="s0"># Ecliptic latitude for zodiacal light.</span>
<a name="l21"><span class="ln">21   </span></a><span class="s0">#%% md 
<a name="l22"><span class="ln">22   </span></a></span><span class="s1"># Define possible band properties for ch4. 
<a name="l23"><span class="ln">23   </span></a></span><span class="s0">#%% 
<a name="l24"><span class="ln">24   </span></a></span><span class="s2">import </span><span class="s1">astropy.units </span><span class="s2">as </span><span class="s1">u</span>
<a name="l25"><span class="ln">25   </span></a><span class="s0">#%% 
<a name="l26"><span class="ln">26   </span></a></span><span class="s1">params.bands = [</span><span class="s3">'k0'</span><span class="s2">, </span><span class="s3">'k1'</span><span class="s2">, </span><span class="s3">'k2'</span><span class="s2">, </span><span class="s3">'k3'</span><span class="s1">]</span>
<a name="l27"><span class="ln">27   </span></a><span class="s1">params.band_wls = {</span>
<a name="l28"><span class="ln">28   </span></a>    <span class="s3">'k0'</span><span class="s1">: [</span><span class="s4">2.0</span><span class="s1">*u.um</span><span class="s2">, </span><span class="s4">2.5</span><span class="s1">*u.um]</span><span class="s2">,  </span><span class="s0"># Original.</span>
<a name="l29"><span class="ln">29   </span></a>    <span class="s3">'k1'</span><span class="s1">: [</span><span class="s4">1.7</span><span class="s1">*u.um</span><span class="s2">, </span><span class="s4">2.1</span><span class="s1">*u.um]</span><span class="s2">,  </span><span class="s0"># Case 1.</span>
<a name="l30"><span class="ln">30   </span></a>    <span class="s3">'k2'</span><span class="s1">: [</span><span class="s4">1.7</span><span class="s1">*u.um</span><span class="s2">, </span><span class="s4">2.0</span><span class="s1">*u.um]</span><span class="s2">,  </span><span class="s0"># Case 2.</span>
<a name="l31"><span class="ln">31   </span></a>    <span class="s3">'k3'</span><span class="s1">: [</span><span class="s4">1.6</span><span class="s1">*u.um</span><span class="s2">, </span><span class="s4">2.0</span><span class="s1">*u.um]</span><span class="s2">,  </span><span class="s0"># Case 3.</span>
<a name="l32"><span class="ln">32   </span></a><span class="s1">}</span>
<a name="l33"><span class="ln">33   </span></a><span class="s0">#%% md 
<a name="l34"><span class="ln">34   </span></a></span><span class="s1"># Zeromag calculation for newly defined bands. 
<a name="l35"><span class="ln">35   </span></a></span><span class="s0">#%% 
<a name="l36"><span class="ln">36   </span></a></span><span class="s1">c_zeromag = simimg.get_zeromag(params.band_wls)</span>
<a name="l37"><span class="ln">37   </span></a><span class="s0">#%% 
<a name="l38"><span class="ln">38   </span></a></span><span class="s1">c_zeromag</span>
<a name="l39"><span class="ln">39   </span></a><span class="s0">#%% md 
<a name="l40"><span class="ln">40   </span></a></span><span class="s1"># Zodiacal light photon flux density for newly defined bands. 
<a name="l41"><span class="ln">41   </span></a></span><span class="s0">#%% 
<a name="l42"><span class="ln">42   </span></a></span><span class="s2">from </span><span class="s1">zodiacal.zodiacallight </span><span class="s2">import </span><span class="s1">ZodiacalLight</span>
<a name="l43"><span class="ln">43   </span></a><span class="s0">#%% 
<a name="l44"><span class="ln">44   </span></a></span><span class="s1">zd = ZodiacalLight()</span>
<a name="l45"><span class="ln">45   </span></a><span class="s0">#%% 
<a name="l46"><span class="ln">46   </span></a></span><span class="s1">zdpfd = {}  </span><span class="s0"># ZD photon flux density dict.</span>
<a name="l47"><span class="ln">47   </span></a><span class="s0">#%% 
<a name="l48"><span class="ln">48   </span></a></span><span class="s2">for </span><span class="s1">band </span><span class="s2">in </span><span class="s1">params.bands:</span>
<a name="l49"><span class="ln">49   </span></a>    <span class="s1">zlpflux = zd.get_zl_photonflux_wlinteg(params.band_wls[band][</span><span class="s4">0</span><span class="s1">].value</span><span class="s2">,</span>
<a name="l50"><span class="ln">50   </span></a>                                           <span class="s1">params.band_wls[band][</span><span class="s4">1</span><span class="s1">].value</span><span class="s2">,</span>
<a name="l51"><span class="ln">51   </span></a>                                           <span class="s1">zd_elat</span><span class="s2">, </span><span class="s1">unit=</span><span class="s2">True</span><span class="s1">)</span>
<a name="l52"><span class="ln">52   </span></a>    <span class="s1">zdpfd[band] = zlpflux</span>
<a name="l53"><span class="ln">53   </span></a><span class="s0">#%% 
<a name="l54"><span class="ln">54   </span></a></span><span class="s1">print(zdpfd)</span>
<a name="l55"><span class="ln">55   </span></a><span class="s0">#%% md 
<a name="l56"><span class="ln">56   </span></a></span><span class="s1"># Dark 
<a name="l57"><span class="ln">57   </span></a></span><span class="s0">#%% 
<a name="l58"><span class="ln">58   </span></a></span><span class="s1">params.darkrate  </span><span class="s0"># To be multiplied by exposure time and total pixel numbers.</span>
<a name="l59"><span class="ln">59   </span></a><span class="s0">#%% md 
<a name="l60"><span class="ln">60   </span></a></span><span class="s1"># Black body radiation from the instrument. 
<a name="l61"><span class="ln">61   </span></a></span><span class="s0">#%% 
<a name="l62"><span class="ln">62   </span></a></span><span class="s2">import </span><span class="s1">numpy </span><span class="s2">as </span><span class="s1">np</span>
<a name="l63"><span class="ln">63   </span></a><span class="s2">from </span><span class="s1">scipy </span><span class="s2">import </span><span class="s1">integrate</span>
<a name="l64"><span class="ln">64   </span></a>
<a name="l65"><span class="ln">65   </span></a><span class="s2">import </span><span class="s1">astropy.constants </span><span class="s2">as </span><span class="s1">c</span>
<a name="l66"><span class="ln">66   </span></a><span class="s2">from </span><span class="s1">astropy.modeling </span><span class="s2">import </span><span class="s1">models</span>
<a name="l67"><span class="ln">67   </span></a><span class="s0">#%% md 
<a name="l68"><span class="ln">68   </span></a></span><span class="s1">## Calculate photon flux density for an integrated band. 
<a name="l69"><span class="ln">69   </span></a></span><span class="s0">#%% 
<a name="l70"><span class="ln">70   </span></a></span><span class="s2">def </span><span class="s1">bb_photon_flux_density(temperature: float</span><span class="s2">, </span><span class="s1">wl1: float</span><span class="s2">, </span><span class="s1">wl2: float):</span>
<a name="l71"><span class="ln">71   </span></a>    <span class="s5">&quot;&quot;&quot; 
<a name="l72"><span class="ln">72   </span></a>    Calculate photon flux density of black body integrated between wl1 and wl2. 
<a name="l73"><span class="ln">73   </span></a>    :param temperature: Black body temperature (float) [K] 
<a name="l74"><span class="ln">74   </span></a>    :param wl1: Min. wavelength (float) [um] 
<a name="l75"><span class="ln">75   </span></a>    :param wl2: Max. wavelength (float) [um] 
<a name="l76"><span class="ln">76   </span></a>    &quot;&quot;&quot;</span>
<a name="l77"><span class="ln">77   </span></a>    <span class="s0"># Define blackbody model as wavelength function</span>
<a name="l78"><span class="ln">78   </span></a>    <span class="s1">bb_wl = models.BlackBody(temperature=temperature*u.K</span><span class="s2">, </span><span class="s1">scale=</span><span class="s4">1.0</span><span class="s1">*u.erg/u.cm**</span><span class="s4">2</span><span class="s1">/u.AA/u.s/u.sr)</span>
<a name="l79"><span class="ln">79   </span></a>    <span class="s0"># Integration between wl1 and wl2.</span>
<a name="l80"><span class="ln">80   </span></a>    <span class="s1">bb_photon_flux_density = integrate.quad(</span><span class="s2">lambda </span><span class="s1">x:</span>
<a name="l81"><span class="ln">81   </span></a>                                            <span class="s1">((bb_wl(x*u.um)/(c.h*c.c/(x*u.um))).to(</span><span class="s4">1.0</span><span class="s1">/u.um/u.cm**</span><span class="s4">2</span><span class="s1">/u.s/u.sr)).value</span><span class="s2">,</span>
<a name="l82"><span class="ln">82   </span></a>                                            <span class="s1">wl1</span><span class="s2">, </span><span class="s1">wl2)</span>
<a name="l83"><span class="ln">83   </span></a>    <span class="s0"># Return wavelength-integrated photon flux density with a unit (as Quantity).</span>
<a name="l84"><span class="ln">84   </span></a>    <span class="s2">return </span><span class="s1">bb_photon_flux_density[</span><span class="s4">0</span><span class="s1">] * (</span><span class="s4">1.0 </span><span class="s1">/ u.cm ** </span><span class="s4">2 </span><span class="s1">/ u.s / u.sr)</span>
<a name="l85"><span class="ln">85   </span></a><span class="s0">#%% md 
<a name="l86"><span class="ln">86   </span></a></span><span class="s1"># Readout noise. 
<a name="l87"><span class="ln">87   </span></a></span><span class="s0">#%% 
<a name="l88"><span class="ln">88   </span></a></span><span class="s1">rno_squared = params.ron**</span><span class="s4">2 </span><span class="s1">* n_pix</span>
<a name="l89"><span class="ln">89   </span></a><span class="s0">#%% 
<a name="l90"><span class="ln">90   </span></a></span><span class="s1">rno_squared</span>
<a name="l91"><span class="ln">91   </span></a><span class="s0">#%% md 
<a name="l92"><span class="ln">92   </span></a></span><span class="s1"># Calculation of emerged signals for each element. 
<a name="l93"><span class="ln">93   </span></a></span><span class="s0">#%% 
<a name="l94"><span class="ln">94   </span></a># Sample condition.</span>
<a name="l95"><span class="ln">95   </span></a><span class="s1">band = </span><span class="s3">'k0'</span>
<a name="l96"><span class="ln">96   </span></a><span class="s1">temperature = </span><span class="s4">270.0</span>
<a name="l97"><span class="ln">97   </span></a><span class="s1">mag = </span><span class="s4">20.0</span>
<a name="l98"><span class="ln">98   </span></a><span class="s0">#%% 
<a name="l99"><span class="ln">99   </span></a># Emissivity of the M1.</span>
<a name="l100"><span class="ln">100  </span></a><span class="s1">emissivity_m1 = </span><span class="s4">0.1</span>
<a name="l101"><span class="ln">101  </span></a><span class="s0">#%% md 
<a name="l102"><span class="ln">102  </span></a></span><span class="s1">## Signal. 
<a name="l103"><span class="ln">103  </span></a></span><span class="s0">#%% 
<a name="l104"><span class="ln">104  </span></a># Stellar object.</span>
<a name="l105"><span class="ln">105  </span></a><span class="s1">ph_obj = (c_zeromag[band] * </span><span class="s4">10</span><span class="s1">**(-mag/</span><span class="s4">2.5</span><span class="s1">) * params.t_exp *</span>
<a name="l106"><span class="ln">106  </span></a>          <span class="s1">(params.d_tel/</span><span class="s4">2.0</span><span class="s1">)**</span><span class="s4">2.0</span><span class="s1">*np.pi * params.eff_tel).decompose().value</span>
<a name="l107"><span class="ln">107  </span></a><span class="s0">#%% 
<a name="l108"><span class="ln">108  </span></a></span><span class="s1">ph_obj</span>
<a name="l109"><span class="ln">109  </span></a><span class="s0">#%% 
<a name="l110"><span class="ln">110  </span></a># Dark.</span>
<a name="l111"><span class="ln">111  </span></a><span class="s1">ph_dk = (params.darkrate * params.t_exp * n_pix).decompose().value</span>
<a name="l112"><span class="ln">112  </span></a><span class="s0">#%% 
<a name="l113"><span class="ln">113  </span></a></span><span class="s1">ph_dk</span>
<a name="l114"><span class="ln">114  </span></a><span class="s0">#%% 
<a name="l115"><span class="ln">115  </span></a># Zodiacal light.</span>
<a name="l116"><span class="ln">116  </span></a><span class="s1">ph_zd = (zdpfd[band] * params.t_exp * (params.d_tel/</span><span class="s4">2.0</span><span class="s1">)**</span><span class="s4">2.0</span><span class="s1">*np.pi * params.eff_tel *</span>
<a name="l117"><span class="ln">117  </span></a>         <span class="s1">params.pix_fov * n_pix).decompose().value</span>
<a name="l118"><span class="ln">118  </span></a><span class="s0">#%% 
<a name="l119"><span class="ln">119  </span></a></span><span class="s1">ph_zd</span>
<a name="l120"><span class="ln">120  </span></a><span class="s0">#%% 
<a name="l121"><span class="ln">121  </span></a># Thermal emission of instruments.</span>
<a name="l122"><span class="ln">122  </span></a><span class="s1">ph_th = (bb_photon_flux_density(temperature</span><span class="s2">,</span>
<a name="l123"><span class="ln">123  </span></a>                               <span class="s1">params.band_wls[band][</span><span class="s4">0</span><span class="s1">].value</span><span class="s2">, </span><span class="s1">params.band_wls[band][</span><span class="s4">1</span><span class="s1">].value) * \</span>
<a name="l124"><span class="ln">124  </span></a>    <span class="s1">emissivity_m1 * \</span>
<a name="l125"><span class="ln">125  </span></a>    <span class="s1">params.t_exp * (params.d_tel/</span><span class="s4">2.0</span><span class="s1">)**</span><span class="s4">2.0</span><span class="s1">*np.pi * params.eff_tel * params.pix_fov * n_pix).decompose().value</span>
<a name="l126"><span class="ln">126  </span></a><span class="s0">#%% 
<a name="l127"><span class="ln">127  </span></a></span><span class="s1">ph_th</span>
<a name="l128"><span class="ln">128  </span></a><span class="s0">#%% 
<a name="l129"><span class="ln">129  </span></a></span><span class="s1">sig_total = ph_obj</span>
<a name="l130"><span class="ln">130  </span></a><span class="s1">count_total = ph_obj + ph_dk + ph_zd + ph_th</span>
<a name="l131"><span class="ln">131  </span></a><span class="s0">#%% 
<a name="l132"><span class="ln">132  </span></a></span><span class="s1">print(sig_total</span><span class="s2">, </span><span class="s1">count_total)</span>
<a name="l133"><span class="ln">133  </span></a><span class="s0">#%% md 
<a name="l134"><span class="ln">134  </span></a></span><span class="s1">## Noise. 
<a name="l135"><span class="ln">135  </span></a></span><span class="s0">#%% md 
<a name="l136"><span class="ln">136  </span></a></span>
<a name="l137"><span class="ln">137  </span></a><span class="s0">#%% 
<a name="l138"><span class="ln">138  </span></a></span><span class="s1">noise_total = np.sqrt(count_total +params.ron**</span><span class="s4">2 </span><span class="s1">* n_pix)</span>
<a name="l139"><span class="ln">139  </span></a><span class="s0">#%% 
<a name="l140"><span class="ln">140  </span></a></span><span class="s1">noise_total</span>
<a name="l141"><span class="ln">141  </span></a><span class="s0">#%% 
<a name="l142"><span class="ln">142  </span></a></span><span class="s1">sn = sig_total /noise_total</span>
<a name="l143"><span class="ln">143  </span></a><span class="s0">#%% 
<a name="l144"><span class="ln">144  </span></a></span><span class="s1">sn</span>
<a name="l145"><span class="ln">145  </span></a><span class="s0">#%% md 
<a name="l146"><span class="ln">146  </span></a></span><span class="s1"># General function for calculate signals and noises. 
<a name="l147"><span class="ln">147  </span></a></span><span class="s0">#%% 
<a name="l148"><span class="ln">148  </span></a></span><span class="s2">def </span><span class="s1">get_signals_and_noises(_params: simimg.HZGParams</span><span class="s2">, </span><span class="s1">_temperature</span><span class="s2">, </span><span class="s1">_mag</span><span class="s2">, </span><span class="s1">_band</span><span class="s2">, </span><span class="s1">_n_pix</span><span class="s2">, </span><span class="s1">_emissivity_m1):</span>
<a name="l149"><span class="ln">149  </span></a>    <span class="s0"># Stellar object.</span>
<a name="l150"><span class="ln">150  </span></a>    <span class="s1">_ph_obj = (c_zeromag[band] * </span><span class="s4">10 </span><span class="s1">** (-_mag / </span><span class="s4">2.5</span><span class="s1">) * _params.t_exp *</span>
<a name="l151"><span class="ln">151  </span></a>          <span class="s1">(_params.d_tel / </span><span class="s4">2.0</span><span class="s1">) ** </span><span class="s4">2.0 </span><span class="s1">* np.pi * _params.eff_tel).decompose().value</span>
<a name="l152"><span class="ln">152  </span></a>    <span class="s0"># Dark.</span>
<a name="l153"><span class="ln">153  </span></a>    <span class="s1">_ph_dk = (_params.darkrate * _params.t_exp * _n_pix).decompose().value</span>
<a name="l154"><span class="ln">154  </span></a>    <span class="s0"># Zodiacal light.</span>
<a name="l155"><span class="ln">155  </span></a>    <span class="s1">_ph_zd = (zdpfd[band] * _params.t_exp * (_params.d_tel/</span><span class="s4">2.0</span><span class="s1">)**</span><span class="s4">2.0</span><span class="s1">*np.pi * _params.eff_tel *</span>
<a name="l156"><span class="ln">156  </span></a>         <span class="s1">_params.pix_fov * _n_pix).decompose().value</span>
<a name="l157"><span class="ln">157  </span></a>    <span class="s0"># Thermal emission of instruments.</span>
<a name="l158"><span class="ln">158  </span></a>    <span class="s1">_ph_th = (bb_photon_flux_density(_temperature</span><span class="s2">,</span>
<a name="l159"><span class="ln">159  </span></a>                                     <span class="s1">_params.band_wls[_band][</span><span class="s4">0</span><span class="s1">].value</span><span class="s2">, </span><span class="s1">_params.band_wls[_band][</span><span class="s4">1</span><span class="s1">].value) * \</span>
<a name="l160"><span class="ln">160  </span></a>              <span class="s1">_emissivity_m1 *</span>
<a name="l161"><span class="ln">161  </span></a>              <span class="s1">_params.t_exp * (_params.d_tel / </span><span class="s4">2.0</span><span class="s1">) ** </span><span class="s4">2.0 </span><span class="s1">*</span>
<a name="l162"><span class="ln">162  </span></a>              <span class="s1">np.pi * _params.eff_tel * _params.pix_fov * _n_pix).decompose().value</span>
<a name="l163"><span class="ln">163  </span></a>    <span class="s1">_sig_total = _ph_obj</span>
<a name="l164"><span class="ln">164  </span></a>    <span class="s1">_count_total = _ph_obj + _ph_dk + _ph_zd + _ph_th</span>
<a name="l165"><span class="ln">165  </span></a>    <span class="s1">_noise_ron = np.sqrt(_params.ron**</span><span class="s4">2 </span><span class="s1">* _n_pix)</span>
<a name="l166"><span class="ln">166  </span></a>    <span class="s1">_noise_total = np.sqrt(_count_total + _noise_ron**</span><span class="s4">2</span><span class="s1">)</span>
<a name="l167"><span class="ln">167  </span></a>    <span class="s1">_sn = _sig_total / _noise_total</span>
<a name="l168"><span class="ln">168  </span></a>    <span class="s2">return </span><span class="s1">(_band</span><span class="s2">, </span><span class="s1">_temperature</span><span class="s2">, </span><span class="s1">_mag</span><span class="s2">, </span><span class="s1">_sn</span><span class="s2">, </span><span class="s1">_ph_obj</span><span class="s2">, </span><span class="s1">_ph_dk</span><span class="s2">, </span><span class="s1">_ph_zd</span><span class="s2">, </span><span class="s1">ph_th</span><span class="s2">, </span><span class="s1">_noise_ron)</span>
<a name="l169"><span class="ln">169  </span></a><span class="s0">#%% 
<a name="l170"><span class="ln">170  </span></a></span><span class="s1">get_signals_and_noises(params</span><span class="s2">, </span><span class="s4">230.0</span><span class="s2">, </span><span class="s4">20.0</span><span class="s2">, </span><span class="s3">'k0'</span><span class="s2">, </span><span class="s4">9</span><span class="s2">, </span><span class="s4">0.1</span><span class="s1">)</span>
<a name="l171"><span class="ln">171  </span></a><span class="s0">#%% md 
<a name="l172"><span class="ln">172  </span></a></span><span class="s1">calculation sample. (t=170, 'k0') 
<a name="l173"><span class="ln">173  </span></a></span><span class="s0">#%% 
<a name="l174"><span class="ln">174  </span></a></span><span class="s1">params.t_exp = </span><span class="s4">120.0</span><span class="s1">*</span><span class="s4">5</span>
<a name="l175"><span class="ln">175  </span></a><span class="s0">#%% 
<a name="l176"><span class="ln">176  </span></a></span><span class="s1">get_signals_and_noises(params</span><span class="s2">, </span><span class="s4">170.0</span><span class="s2">, </span><span class="s4">20.0</span><span class="s2">, </span><span class="s3">'k0'</span><span class="s2">, </span><span class="s4">9</span><span class="s1">*</span><span class="s4">5</span><span class="s2">, </span><span class="s4">0.1</span><span class="s1">)</span>
<a name="l177"><span class="ln">177  </span></a><span class="s0">#%% 
<a name="l178"><span class="ln">178  </span></a></span><span class="s1">emissivity_m1 = </span><span class="s4">0.1</span>
<a name="l179"><span class="ln">179  </span></a><span class="s1">mags = []</span>
<a name="l180"><span class="ln">180  </span></a><span class="s1">sns = {</span><span class="s3">'k0'</span><span class="s1">: []</span><span class="s2">, </span><span class="s3">'k1'</span><span class="s1">: []</span><span class="s2">, </span><span class="s3">'k2'</span><span class="s1">: []</span><span class="s2">, </span><span class="s3">'k3'</span><span class="s1">: []}</span>
<a name="l181"><span class="ln">181  </span></a><span class="s2">for </span><span class="s1">mag </span><span class="s2">in </span><span class="s1">np.linspace(</span><span class="s4">17.0</span><span class="s2">, </span><span class="s4">22.0</span><span class="s2">, </span><span class="s4">101</span><span class="s1">):</span>
<a name="l182"><span class="ln">182  </span></a>    <span class="s1">mags.append(mag)</span>
<a name="l183"><span class="ln">183  </span></a>    <span class="s2">for </span><span class="s1">band </span><span class="s2">in </span><span class="s1">params.bands:</span>
<a name="l184"><span class="ln">184  </span></a>        <span class="s1">result = get_signals_and_noises(params</span><span class="s2">, </span><span class="s1">t</span><span class="s2">, </span><span class="s1">mag</span><span class="s2">, </span><span class="s1">band</span><span class="s2">, </span><span class="s4">9</span><span class="s1">*</span><span class="s4">5</span><span class="s2">, </span><span class="s1">emissivity_m1)</span>
<a name="l185"><span class="ln">185  </span></a>        <span class="s1">sns[band].append(result[</span><span class="s4">3</span><span class="s1">])</span>
<a name="l186"><span class="ln">186  </span></a><span class="s0">#%% 
<a name="l187"><span class="ln">187  </span></a></span><span class="s2">import </span><span class="s1">matplotlib.pyplot </span><span class="s2">as </span><span class="s1">plt</span>
<a name="l188"><span class="ln">188  </span></a><span class="s0">#%% 
<a name="l189"><span class="ln">189  </span></a></span><span class="s1">plt.figure(figsize=(</span><span class="s4">12</span><span class="s2">,</span><span class="s4">8</span><span class="s1">))</span>
<a name="l190"><span class="ln">190  </span></a><span class="s1">plt.grid()</span>
<a name="l191"><span class="ln">191  </span></a><span class="s1">plt.xlim([</span><span class="s4">18</span><span class="s2">, </span><span class="s4">22</span><span class="s1">])</span>
<a name="l192"><span class="ln">192  </span></a><span class="s1">plt.ylim([</span><span class="s4">0</span><span class="s2">,</span><span class="s4">60</span><span class="s1">])</span>
<a name="l193"><span class="ln">193  </span></a><span class="s1">plt.xlabel(</span><span class="s3">'mag'</span><span class="s1">)</span>
<a name="l194"><span class="ln">194  </span></a><span class="s1">plt.ylabel(</span><span class="s3">'SN ratio'</span><span class="s1">)</span>
<a name="l195"><span class="ln">195  </span></a><span class="s1">plt.title(</span><span class="s3">'Temperature={} K, M1 emissivity={:.2f}, Exp.={} s'</span><span class="s1">.format(t</span><span class="s2">, </span><span class="s1">emissivity_m1</span><span class="s2">, </span><span class="s1">params.t_exp))</span>
<a name="l196"><span class="ln">196  </span></a><span class="s1">plt.plot(mags</span><span class="s2">, </span><span class="s1">sns[</span><span class="s3">'k0'</span><span class="s1">]</span><span class="s2">, </span><span class="s1">label = </span><span class="s3">'2.0-2.5 um'</span><span class="s1">)</span>
<a name="l197"><span class="ln">197  </span></a><span class="s1">plt.plot(mags</span><span class="s2">, </span><span class="s1">sns[</span><span class="s3">'k1'</span><span class="s1">]</span><span class="s2">, </span><span class="s1">label = </span><span class="s3">'1.7-2.1 um'</span><span class="s1">)</span>
<a name="l198"><span class="ln">198  </span></a><span class="s1">plt.plot(mags</span><span class="s2">, </span><span class="s1">sns[</span><span class="s3">'k2'</span><span class="s1">]</span><span class="s2">, </span><span class="s1">label = </span><span class="s3">'1.7-2.0 um'</span><span class="s1">)</span>
<a name="l199"><span class="ln">199  </span></a><span class="s1">plt.plot(mags</span><span class="s2">, </span><span class="s1">sns[</span><span class="s3">'k3'</span><span class="s1">]</span><span class="s2">, </span><span class="s1">label = </span><span class="s3">'1.6-2.0 um'</span><span class="s1">)</span>
<a name="l200"><span class="ln">200  </span></a><span class="s1">plt.legend()</span>
<a name="l201"><span class="ln">201  </span></a><span class="s1">plt.plot([</span><span class="s4">17.0</span><span class="s2">, </span><span class="s4">22.0</span><span class="s1">]</span><span class="s2">, </span><span class="s1">[</span><span class="s4">10</span><span class="s2">, </span><span class="s4">10</span><span class="s1">])</span>
<a name="l202"><span class="ln">202  </span></a><span class="s1">plt.show()</span>
<a name="l203"><span class="ln">203  </span></a><span class="s0">#%% 
<a name="l204"><span class="ln">204  </span></a></span><span class="s1">emissivity_m1_2 = </span><span class="s4">0.0</span>
<a name="l205"><span class="ln">205  </span></a><span class="s1">mags2 = []</span>
<a name="l206"><span class="ln">206  </span></a><span class="s1">sns2 = {</span><span class="s3">'k0'</span><span class="s1">: []</span><span class="s2">, </span><span class="s3">'k1'</span><span class="s1">: []</span><span class="s2">, </span><span class="s3">'k2'</span><span class="s1">: []</span><span class="s2">, </span><span class="s3">'k3'</span><span class="s1">: []}</span>
<a name="l207"><span class="ln">207  </span></a><span class="s2">for </span><span class="s1">mag </span><span class="s2">in </span><span class="s1">np.linspace(</span><span class="s4">17.0</span><span class="s2">, </span><span class="s4">22.0</span><span class="s2">, </span><span class="s4">101</span><span class="s1">):</span>
<a name="l208"><span class="ln">208  </span></a>    <span class="s1">mags2.append(mag)</span>
<a name="l209"><span class="ln">209  </span></a>    <span class="s2">for </span><span class="s1">band </span><span class="s2">in </span><span class="s1">params.bands:</span>
<a name="l210"><span class="ln">210  </span></a>        <span class="s1">result = get_signals_and_noises(params</span><span class="s2">, </span><span class="s1">t</span><span class="s2">, </span><span class="s1">mag</span><span class="s2">, </span><span class="s1">band</span><span class="s2">, </span><span class="s4">9</span><span class="s1">*</span><span class="s4">5</span><span class="s2">, </span><span class="s1">emissivity_m1_2)</span>
<a name="l211"><span class="ln">211  </span></a>        <span class="s1">sns2[band].append(result[</span><span class="s4">3</span><span class="s1">])</span>
<a name="l212"><span class="ln">212  </span></a><span class="s0">#%% 
<a name="l213"><span class="ln">213  </span></a></span><span class="s1">plt.figure(figsize=(</span><span class="s4">12</span><span class="s2">,</span><span class="s4">8</span><span class="s1">))</span>
<a name="l214"><span class="ln">214  </span></a><span class="s1">plt.grid()</span>
<a name="l215"><span class="ln">215  </span></a><span class="s1">plt.xlim([</span><span class="s4">18</span><span class="s2">, </span><span class="s4">22</span><span class="s1">])</span>
<a name="l216"><span class="ln">216  </span></a><span class="s1">plt.ylim([</span><span class="s4">0</span><span class="s2">,</span><span class="s4">60</span><span class="s1">])</span>
<a name="l217"><span class="ln">217  </span></a><span class="s1">plt.xlabel(</span><span class="s3">'mag'</span><span class="s1">)</span>
<a name="l218"><span class="ln">218  </span></a><span class="s1">plt.ylabel(</span><span class="s3">'SN ratio'</span><span class="s1">)</span>
<a name="l219"><span class="ln">219  </span></a><span class="s1">plt.title(</span><span class="s3">'Temperature={} K, M1 emissivity={:.2f}'</span><span class="s1">.format(t</span><span class="s2">, </span><span class="s1">emissivity_m1_2))</span>
<a name="l220"><span class="ln">220  </span></a><span class="s1">plt.plot(mags2</span><span class="s2">, </span><span class="s1">sns2[</span><span class="s3">'k0'</span><span class="s1">]</span><span class="s2">, </span><span class="s1">label = </span><span class="s3">'2.0-2.5 um'</span><span class="s1">)</span>
<a name="l221"><span class="ln">221  </span></a><span class="s1">plt.plot(mags2</span><span class="s2">, </span><span class="s1">sns2[</span><span class="s3">'k1'</span><span class="s1">]</span><span class="s2">, </span><span class="s1">label = </span><span class="s3">'1.7-2.1 um'</span><span class="s1">)</span>
<a name="l222"><span class="ln">222  </span></a><span class="s1">plt.plot(mags2</span><span class="s2">, </span><span class="s1">sns2[</span><span class="s3">'k2'</span><span class="s1">]</span><span class="s2">, </span><span class="s1">label = </span><span class="s3">'1.7-2.0 um'</span><span class="s1">)</span>
<a name="l223"><span class="ln">223  </span></a><span class="s1">plt.plot(mags2</span><span class="s2">, </span><span class="s1">sns2[</span><span class="s3">'k3'</span><span class="s1">]</span><span class="s2">, </span><span class="s1">label = </span><span class="s3">'1.6-2.0 um'</span><span class="s1">)</span>
<a name="l224"><span class="ln">224  </span></a><span class="s1">plt.legend()</span>
<a name="l225"><span class="ln">225  </span></a><span class="s1">plt.plot([</span><span class="s4">17.0</span><span class="s2">, </span><span class="s4">22.0</span><span class="s1">]</span><span class="s2">, </span><span class="s1">[</span><span class="s4">10</span><span class="s2">, </span><span class="s4">10</span><span class="s1">])</span>
<a name="l226"><span class="ln">226  </span></a><span class="s1">plt.show()</span>
<a name="l227"><span class="ln">227  </span></a><span class="s0">#%% 
<a name="l228"><span class="ln">228  </span></a></span><span class="s1">t3 = </span><span class="s4">200</span>
<a name="l229"><span class="ln">229  </span></a><span class="s1">emissivity_m1_3 = </span><span class="s4">0.1</span>
<a name="l230"><span class="ln">230  </span></a><span class="s1">mags3 = []</span>
<a name="l231"><span class="ln">231  </span></a><span class="s1">sns3 = {</span><span class="s3">'k0'</span><span class="s1">: []</span><span class="s2">, </span><span class="s3">'k1'</span><span class="s1">: []</span><span class="s2">, </span><span class="s3">'k2'</span><span class="s1">: []</span><span class="s2">, </span><span class="s3">'k3'</span><span class="s1">: []}</span>
<a name="l232"><span class="ln">232  </span></a><span class="s2">for </span><span class="s1">mag </span><span class="s2">in </span><span class="s1">np.linspace(</span><span class="s4">17.0</span><span class="s2">, </span><span class="s4">22.0</span><span class="s2">, </span><span class="s4">101</span><span class="s1">):</span>
<a name="l233"><span class="ln">233  </span></a>    <span class="s1">mags3.append(mag)</span>
<a name="l234"><span class="ln">234  </span></a>    <span class="s2">for </span><span class="s1">band </span><span class="s2">in </span><span class="s1">params.bands:</span>
<a name="l235"><span class="ln">235  </span></a>        <span class="s1">result = get_signals_and_noises(params</span><span class="s2">, </span><span class="s1">t3</span><span class="s2">, </span><span class="s1">mag</span><span class="s2">, </span><span class="s1">band</span><span class="s2">, </span><span class="s4">9</span><span class="s1">*</span><span class="s4">5</span><span class="s2">, </span><span class="s1">emissivity_m1_3)</span>
<a name="l236"><span class="ln">236  </span></a>        <span class="s1">sns3[band].append(result[</span><span class="s4">3</span><span class="s1">])</span>
<a name="l237"><span class="ln">237  </span></a><span class="s0">#%% 
<a name="l238"><span class="ln">238  </span></a></span><span class="s1">plt.figure(figsize=(</span><span class="s4">12</span><span class="s2">,</span><span class="s4">8</span><span class="s1">))</span>
<a name="l239"><span class="ln">239  </span></a><span class="s1">plt.grid()</span>
<a name="l240"><span class="ln">240  </span></a><span class="s1">plt.xlim([</span><span class="s4">18</span><span class="s2">, </span><span class="s4">22</span><span class="s1">])</span>
<a name="l241"><span class="ln">241  </span></a><span class="s1">plt.ylim([</span><span class="s4">0</span><span class="s2">,</span><span class="s4">60</span><span class="s1">])</span>
<a name="l242"><span class="ln">242  </span></a><span class="s1">plt.xlabel(</span><span class="s3">'mag'</span><span class="s1">)</span>
<a name="l243"><span class="ln">243  </span></a><span class="s1">plt.ylabel(</span><span class="s3">'SN ratio'</span><span class="s1">)</span>
<a name="l244"><span class="ln">244  </span></a><span class="s1">plt.title(</span><span class="s3">'Temperature={} K, M1 emissivity={:.2f}'</span><span class="s1">.format(t3</span><span class="s2">, </span><span class="s1">emissivity_m1_3))</span>
<a name="l245"><span class="ln">245  </span></a><span class="s1">plt.plot(mags3</span><span class="s2">, </span><span class="s1">sns3[</span><span class="s3">'k0'</span><span class="s1">]</span><span class="s2">, </span><span class="s1">label = </span><span class="s3">'2.0-2.5 um'</span><span class="s1">)</span>
<a name="l246"><span class="ln">246  </span></a><span class="s1">plt.plot(mags3</span><span class="s2">, </span><span class="s1">sns3[</span><span class="s3">'k1'</span><span class="s1">]</span><span class="s2">, </span><span class="s1">label = </span><span class="s3">'1.7-2.1 um'</span><span class="s1">)</span>
<a name="l247"><span class="ln">247  </span></a><span class="s1">plt.plot(mags3</span><span class="s2">, </span><span class="s1">sns3[</span><span class="s3">'k2'</span><span class="s1">]</span><span class="s2">, </span><span class="s1">label = </span><span class="s3">'1.7-2.0 um'</span><span class="s1">)</span>
<a name="l248"><span class="ln">248  </span></a><span class="s1">plt.plot(mags3</span><span class="s2">, </span><span class="s1">sns3[</span><span class="s3">'k3'</span><span class="s1">]</span><span class="s2">, </span><span class="s1">label = </span><span class="s3">'1.6-2.0 um'</span><span class="s1">)</span>
<a name="l249"><span class="ln">249  </span></a><span class="s1">plt.legend()</span>
<a name="l250"><span class="ln">250  </span></a><span class="s1">plt.plot([</span><span class="s4">17.0</span><span class="s2">, </span><span class="s4">22.0</span><span class="s1">]</span><span class="s2">, </span><span class="s1">[</span><span class="s4">10</span><span class="s2">, </span><span class="s4">10</span><span class="s1">])</span>
<a name="l251"><span class="ln">251  </span></a><span class="s1">plt.show()</span>
<a name="l252"><span class="ln">252  </span></a><span class="s0">#%% md 
<a name="l253"><span class="ln">253  </span></a></span><span class="s1"># Calculation for actual parameters. 
<a name="l254"><span class="ln">254  </span></a></span><span class="s0">#%% 
<a name="l255"><span class="ln">255  </span></a></span><span class="s2">from </span><span class="s1">astropy.table </span><span class="s2">import </span><span class="s1">QTable</span>
<a name="l256"><span class="ln">256  </span></a><span class="s0">#%% 
<a name="l257"><span class="ln">257  </span></a></span><span class="s1">t1 = </span><span class="s4">200.0</span>
<a name="l258"><span class="ln">258  </span></a><span class="s1">t2 = </span><span class="s4">300.0</span>
<a name="l259"><span class="ln">259  </span></a><span class="s1">tn = </span><span class="s4">11</span>
<a name="l260"><span class="ln">260  </span></a><span class="s1">n_pix = </span><span class="s4">9</span><span class="s1">*</span><span class="s4">5</span>
<a name="l261"><span class="ln">261  </span></a><span class="s1">tbls = {}</span>
<a name="l262"><span class="ln">262  </span></a><span class="s2">for </span><span class="s1">band </span><span class="s2">in </span><span class="s1">[</span><span class="s3">'k0'</span><span class="s2">, </span><span class="s3">'k1'</span><span class="s2">, </span><span class="s3">'k2'</span><span class="s2">, </span><span class="s3">'k3'</span><span class="s1">]:</span>
<a name="l263"><span class="ln">263  </span></a>    <span class="s1">print(band)</span>
<a name="l264"><span class="ln">264  </span></a>    <span class="s1">temps = []</span>
<a name="l265"><span class="ln">265  </span></a>    <span class="s1">mags = []</span>
<a name="l266"><span class="ln">266  </span></a>    <span class="s2">for </span><span class="s1">temperature </span><span class="s2">in </span><span class="s1">np.linspace(t1</span><span class="s2">, </span><span class="s1">t2</span><span class="s2">, </span><span class="s1">tn):</span>
<a name="l267"><span class="ln">267  </span></a>        <span class="s2">for </span><span class="s1">mag </span><span class="s2">in </span><span class="s1">np.linspace(</span><span class="s4">15.0</span><span class="s2">, </span><span class="s4">22.0</span><span class="s2">, </span><span class="s4">101</span><span class="s1">):</span>
<a name="l268"><span class="ln">268  </span></a>            <span class="s1">print(band</span><span class="s2">, </span><span class="s1">mag)</span>
<a name="l269"><span class="ln">269  </span></a>            <span class="s1">result = get_signals_and_noises(params</span><span class="s2">, </span><span class="s1">temperature</span><span class="s2">, </span><span class="s1">mag</span><span class="s2">, </span><span class="s1">band</span><span class="s2">, </span><span class="s1">n_pix</span><span class="s2">, </span><span class="s4">0.1</span><span class="s1">)</span>
<a name="l270"><span class="ln">270  </span></a>            <span class="s2">if </span><span class="s1">result[</span><span class="s4">3</span><span class="s1">] &lt; </span><span class="s4">10.0</span><span class="s1">:</span>
<a name="l271"><span class="ln">271  </span></a>                <span class="s1">temps.append(temperature)</span>
<a name="l272"><span class="ln">272  </span></a>                <span class="s1">mags.append(mag)</span>
<a name="l273"><span class="ln">273  </span></a>                <span class="s1">print(</span><span class="s3">'{:s} {:.2f} {:.2f}'</span><span class="s1">.format(band</span><span class="s2">, </span><span class="s1">temperature</span><span class="s2">, </span><span class="s1">mag))</span>
<a name="l274"><span class="ln">274  </span></a>                <span class="s2">break</span>
<a name="l275"><span class="ln">275  </span></a>    <span class="s1">t = QTable([np.array(temps)</span><span class="s2">, </span><span class="s1">np.array(mags)]</span><span class="s2">, </span><span class="s1">names=(</span><span class="s3">'temperature'</span><span class="s2">, </span><span class="s3">'mag'</span><span class="s1">))</span>
<a name="l276"><span class="ln">276  </span></a>    <span class="s1">tbls[band] = t</span>
<a name="l277"><span class="ln">277  </span></a>
<a name="l278"><span class="ln">278  </span></a><span class="s0">#%% 
<a name="l279"><span class="ln">279  </span></a></span><span class="s1">plt.figure(figsize=(</span><span class="s4">12</span><span class="s2">,</span><span class="s4">8</span><span class="s1">))</span>
<a name="l280"><span class="ln">280  </span></a><span class="s1">plt.grid()</span>
<a name="l281"><span class="ln">281  </span></a><span class="s0">#plt.xlim([18, 22])</span>
<a name="l282"><span class="ln">282  </span></a><span class="s1">plt.ylim([</span><span class="s4">18</span><span class="s2">,</span><span class="s4">20.5</span><span class="s1">])</span>
<a name="l283"><span class="ln">283  </span></a><span class="s1">plt.xlabel(</span><span class="s3">'Temperature [K]'</span><span class="s1">)</span>
<a name="l284"><span class="ln">284  </span></a><span class="s1">plt.ylabel(</span><span class="s3">'Lim. mag. (S/N=10)'</span><span class="s1">)</span>
<a name="l285"><span class="ln">285  </span></a><span class="s1">plt.title(</span><span class="s3">'M1 emissivity={:.2f}, t={:.1f} s'</span><span class="s1">.format(</span><span class="s4">0.1</span><span class="s2">, </span><span class="s1">params.t_exp))</span>
<a name="l286"><span class="ln">286  </span></a><span class="s1">plt.plot(tbls[</span><span class="s3">'k0'</span><span class="s1">][</span><span class="s3">'temperature'</span><span class="s1">]</span><span class="s2">, </span><span class="s1">tbls[</span><span class="s3">'k0'</span><span class="s1">][</span><span class="s3">'mag'</span><span class="s1">]</span><span class="s2">, </span><span class="s1">label = </span><span class="s3">'2.0-2.5 um'</span><span class="s1">)</span>
<a name="l287"><span class="ln">287  </span></a><span class="s1">plt.plot(tbls[</span><span class="s3">'k1'</span><span class="s1">][</span><span class="s3">'temperature'</span><span class="s1">]</span><span class="s2">, </span><span class="s1">tbls[</span><span class="s3">'k1'</span><span class="s1">][</span><span class="s3">'mag'</span><span class="s1">]</span><span class="s2">, </span><span class="s1">label = </span><span class="s3">'1.7-2.1 um'</span><span class="s1">)</span>
<a name="l288"><span class="ln">288  </span></a><span class="s1">plt.plot(tbls[</span><span class="s3">'k2'</span><span class="s1">][</span><span class="s3">'temperature'</span><span class="s1">]</span><span class="s2">, </span><span class="s1">tbls[</span><span class="s3">'k2'</span><span class="s1">][</span><span class="s3">'mag'</span><span class="s1">]</span><span class="s2">, </span><span class="s1">label = </span><span class="s3">'1.7-2.0 um'</span><span class="s1">)</span>
<a name="l289"><span class="ln">289  </span></a><span class="s1">plt.plot(tbls[</span><span class="s3">'k3'</span><span class="s1">][</span><span class="s3">'temperature'</span><span class="s1">]</span><span class="s2">, </span><span class="s1">tbls[</span><span class="s3">'k3'</span><span class="s1">][</span><span class="s3">'mag'</span><span class="s1">]</span><span class="s2">, </span><span class="s1">label = </span><span class="s3">'1.6-2.0 um'</span><span class="s1">)</span>
<a name="l290"><span class="ln">290  </span></a><span class="s1">plt.legend()</span>
<a name="l291"><span class="ln">291  </span></a><span class="s0">#plt.plot([17.0, 22.0], [10, 10])</span>
<a name="l292"><span class="ln">292  </span></a><span class="s1">plt.show()</span></pre>
</body>
</html>